//----------------------------------------Liberies including----------------------------------//

#include <ax12.h>                                                 // Liberies for ax12 servo drive	
#include <Wire.h>                                                 // Liberies for I2C bus

//----------------------------------------Defining -------------------------------------------//

#define BUTTON0 0                                                 // Defining the Input Button on input 0
#define SERVOCOUNT 5                                              // Defining how many servo drives there are uset

//----------------------------------------Position Array--------------------------------------//

int positions[11][5] =                                            // Array to 11 defirent position 
{
  { 412,612,412,612,512  },                                       // Pos 0  - Home Position
  
  {  55,480,928,368,512  },                                       // Pos 1  - before 1 
  
  {  45,450,855,368,512  },                                       // Pos 1  - before 2
  
  {  98,505,788,455,512  },                                       // Pos 2  - pallet on
  
  {  98,505,788,455,100  },                                       // Pos 3  - pallet taked
  
  { 949,636,664,656,100  },                                       // Pos 4  - pallet after
  
  { 821,800,457,570,100  },                                       // Pos 5  - half down *
  
  { 815,820,547,558,100  },                                       // Pos 6  - delivering ready *
  
  { 815,820,547,558,512  },                                       // Pos 7  - delivering *
  
  { 815,750,750,581,512  },                                       // Pos 8  - mod pos*
  
  { 815,700,512,582,512  }                                        // Pos 9  - half down on way up*
};

//----------------------------------------Variables-------------------------------------------//

int id;	                                                          // defining "id" to Integer
int pos;                                                          // defining "pos" to Integer
int steps;                                                        // defining "steps" to Integer
int Bit;                                                          // defining "Bit" to Integer
int Place;                                                        // defining "Place" to Integer
int master;                                                       // defining "master" to Integer
int moving;                                                       // defining "moving" to Integer

//----------------------------------------Artix-M Board setup---------------------------------//

void setup()
{        
  Serial.begin(9600);                                            // opens serial port, sets data rate to 9600 bps
  Wire.begin(8);                                                 // join i2c bus (address optional for master)
  Wire.onReceive(receiveEvent);                                  // register event
  delay(200);                                                    // Wait 0.2sek
  Wire.onRequest(requestEvent);                                  // register event
  delay (3000);                                                  // Wait 3sek for display to be open
  Serial.println("#################################");           // Print
  Serial.println("Serial Communication Established.");           // Print
  Serial.println("#################################");           // Print
  Serial.println(" ");                                           // Print
  pinMode(BUTTON0, INPUT);                                       // Setpin mode 0 to input

  ax12SetRegister2(1, 32, 55);                                   // Set speed to servo drive
  ax12SetRegister2(2, 32, 55);                                   // Set speed to servo drive
  ax12SetRegister2(3, 32, 55);                                   // Set speed to servo drive
  ax12SetRegister2(4, 32, 55);                                   // Set speed to servo drive
  ax12SetRegister2(5, 32, 1023);                                 // Set speed to servo drive

  ax12SetRegister2(1, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(2, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(3, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(4, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(5, 34, 1023);                                 // Set Torq to servo drive
  
  steps = 0;                                                     // Set steps to 0
  Bit = 0;                                                       // Set Bit to 0
  Place = 9;                                                     // Set Place to 9

}


//----------------------------------------Step Programming------------------------------------//

void loop() 
{  
  delay(100);                                                     // Wait 0.1sek
       
  }
  //---------------------------------------Home Step-----------------------------------------//
  if (steps == 0)                                                 // Se if Steps is equal to 0
  {
    Serial.println("Program in step 0");                          // Print

    Serial.println("Run arm to homing position");                 // Print
    ServoRunnigPos(0);                                            // Set the function "ServoRunningPos" to read position 0 i position array

    Serial.println("Turn ready signal on");                       // Print
    Bit = 1;                                                      // Set Bit to 1

    Serial.println("Set step to 1");                              // Print
    steps = 1;                                                    // Set Steps to 1
    Serial.println("wait for signal");                            // Print
  }

  //---------------------------------------Ready Step----------------------------------------//
  if (steps == 1 && master == 1)                                  // Se if Steps is equal to 1 and master sending 1
  {
    Serial.println("Program in step 1");                          // Print
                  
    Serial.println("Run arm to ready position 1");                // Print
    ServoRunnigPos(1);                                            // Set the function "ServoRunningPos" to read position 1 i position array

    Serial.println("Run arm to ready position 2");                // Print
    ServoRunnigPos(2);                                            // Set the function "ServoRunningPos" to read position 2 i position array

    Serial.println("Turn ready signal on");                       // Print
    Bit = 2;                                                      // Set Bit to 2

    Serial.println("Set step to 2");                              // Print
    Serial.println("wait for signal");                            // Print
    steps = 2;                                                    // Set Steps to 2
  }
  
  //-----------------------------Pallet on --> Pallet Grab -->-------------------------------// 
  if (steps == 2 && master == 2)                                  // Se if Steps is equal to 2 and master sending 2
  {
    Serial.println("Program in step 2");                          // Print

    Serial.println("Run arm to pallet on position");              // Print
    ServoRunnigPos(3);                                            // Set the function "ServoRunningPos" to read position 3 i position array

    Serial.println("Run arm to pallet grab");                     // Print
    ServoRunnigPos(4);                                            // Set the function "ServoRunningPos" to read position 4 i position array

    Serial.println("Turn ready signal on");                       // Print
    Bit = 3;                                                      // Set Bit to 3

    Serial.println("Set step to 3");                              // Print
    Serial.println("wait for signal");                            // Print
    steps = 3;                                                    // Set Steps to 3
  }
  
  //------------------------------------Pallet vinkel----------------------------------------//           
  if (steps == 3 && master == 3)                                  // Se if Steps is equal to 3 and master sending 3
  {
    Serial.println("Program in step 3");                          // Print

    Serial.println("Run arm to vinkel position");                 // Print
    ServoRunnigPos(5);                                            // Set the function "ServoRunningPos" to read position 5 i position array

    Serial.println("Turn ready signal on");                       // Print
    Bit = 4;                                                      // Set Bit to 4

    Serial.println("Set step to 4");                              // Print
    Serial.println("wait for signal");                            // Print
    steps = 4;                                                    // Set Setps to 4
  }
  
  //------------------------------------Diliver pallet---------------------------------------//
  if (steps == 4 && master == 4)                                  // Se if Steps is equal to 4 and master sending 4
  {
    Serial.println("Program in step 4");                          // Print

    Serial.println("Run arm to half down position");              // Print
    ServoRunnigPos(6);                                            // Set the function "ServoRunningPos" to read position 6 i position array
    delay(2000);                                                  // Wait 2sek
    
    Serial.println("Run arm to dilivering ready position");       // Print
    ServoRunnigPos(7);                                            // Set the function "ServoRunningPos" to read position 7 i position array
    delay(2000);                                                  // Wait 2sek
    
    Serial.println("Run arm to dilivering position");             // Print
    ServoRunnigPos(8);                                            // Set the function "ServoRunningPos" to read position 8 i position array
    delay(2000);                                                  // Wait 2sek
    
    Serial.println("Run arm to away position");                   // Print
    ServoRunnigPos(9);                                            // Set the function "ServoRunningPos" to read position 9 i position array
    delay(2000);                                                  // Wait 2sek
    
    Serial.println("Run arm to half down on way up position");    // Print
    ServoRunnigPos(10);                                           // Set the function "ServoRunningPos" to read position 10 i position array
    delay(2000);                                                  // Wait 2sek
    
    Serial.println("Run arm to ready position");                  // Print
    ServoRunnigPos(1);                                            // Set the function "ServoRunningPos" to read position 1 i position array
    delay(2000);                                                  // Wait 2sek

    Serial.println("Turn ready signal on");                       // Print
    Bit = 5;                                                      // Set Bit to 5

    Serial.println("Set step to 1");                              // Print
    Serial.println("wait for signal");                            // Print
    steps = 5;                                                    // Set Steps to 5
  }

  //-------------------------------Wait to master is ready again-----------------------------//
  if (steps == 5 && master == 0)                                  // Se if Steps is equal to 5 and master sending 0
  {
    Serial.println("Program in step 5");                          // Print

    Serial.println("Turn ready signal on");                       // Print
    Bit = 1;                                                      // Set Bit to 1

    Serial.println("Set step to 1");                              // Print
    Serial.println("wait for signal");                            // Print
    steps = 1;                                                    // Set Setps to 1
  }
}


//----------------------------Recive command from master---------------------------//

// function that executes whenever data is received from master
// this function is registered as an event, see setup()
void receiveEvent(int howMany) {
  while (1 < Wire.available()) {                                // loop through all but the last
    char c = Wire.read();                                       // receive byte as a character
    Serial.print(c);                                            // print the character
  }
  master = Wire.read();                                         // receive byte as an integer
  Serial.println(master);                                       // print the integer
}

//----------------------------Request command from master--------------------------//

// function that executes whenever data is requested by master
// this function is registered as an event, see setup()
void requestEvent() {
  Wire.write(Bit);                                              // respond with message of 6 bytes
                                                                // as expected by master
}

//----------------------------------------Servo Running Pos----------------------------------//

void ServoRunnigPos(pos)                                        // Servo Running Position function
{
  for (id = 0; id <= 4; id++)                                   // Setting the position for all servos except the gripper which will be set when the robot is at the end distination.
  {
    delay(10);                                                  // Wait 0.01sek
    ax12SetRegister2(id + 1, 30, positions[pos][id]);           // Set position to servo register, and read positions from array
  }
  delay(100);                                                   // Wait 0.1sek
  moving=1;                                                     // Set moving to 1
  while (moving != 0)                                           // The program will loop through this while loop until the robot is at its end position and not moving
  {
    delay(100);                                                 // Wait 0.1sek
    moving =  ax12GetRegister(1,46,1)+                          // checking if the motors are running. If the result is == 0 no servos is moving
              ax12GetRegister(2,46,1)+                          // checking if the motors are running. If the result is == 0 no servos is moving
              ax12GetRegister(3,46,1)+                          // checking if the motors are running. If the result is == 0 no servos is moving
              ax12GetRegister(4,46,1)+                          // checking if the motors are running. If the result is == 0 no servos is moving
              ax12GetRegister(5,46,1);                          // checking if the motors are running. If the result is == 0 no servos is moving
  }
}

